<template>
    <div class="movie_edit_page">
        <HeaderComponent />
        <div class="edit_form">
          <div class="item_to_edit"><label>Titre : </label><input v-model="movie.title"></div>
          <div class="item_to_edit"><label>Affiche : </label><input v-model="movie.img"></div>
          <div class="item_to_edit"><label>Date de sortie : </label><input v-model="movie.year" type="number"></div>
          <div class="item_to_edit"><label>Langage : </label><input v-model="movie.language"></div>
          <div class="item_to_edit"><label>Réalisateur : </label><input v-model="movie.realinfo.name"></div>
          <div class="item_to_edit"><label>Réalisateur (date de naissance) : </label><input v-model="movie.realinfo.birthdate"></div>
          <div class="item_to_edit"><label>Réalisateur (nationalité) : </label><input v-model="movie.realinfo.nationality"></div>
          <div class="item_to_edit"><label>Genre : </label><input v-model="movie.type"></div>
          <div class="item_to_edit"><label>Note : </label><input v-model="movie.grade" type="number" min="1" max="5"><p class="error_grade" v-if="invalid_grad">La note doit être comprise entre 1 et 5</p></div>
        </div>
        <button class="save_button" v-on:click="modify(movie.id)">Enregistrer</button>
        <button class="del_button" v-on:click="delete_item(movie.id)">Supprimer</button>
    </div>
</template>

<script>
// @ is an alias to /src
import HeaderComponent from '@/components/HeaderComponent.vue';

export default {
  name: 'MovieEditView',
  components: {
    HeaderComponent
  },
  data() {
    return{
      movies_list: window.movies_list,
      movie: {type: Object},
      current_movie: {type: Object},
      invalid_grad: false
    }
  },
  methods: {
    modify : function(){
      if((this.movie.grade > 5 || this.movie.grade < 1) && this.movie.grade != null){
        this.invalid_grad = true;
      }
      else{
        this.$router.push('/');
      }
    },
    delete_item : function(id){
      this.movies_list.movies = this.movies_list.movies.filter((item) => item.id != id);
      this.$router.push('/');
    }
  },
  mounted(){
    this.movie = this.movies_list.movies.filter(p => ((p.id === parseInt(this.$route.params.id))));
    this.movie = this.movie[0];
    this.current_movie = this.movies_list.movies.filter(p => ((p.id === parseInt(this.$route.params.id))));
  }
}
</script>

<style>
.movie_edit_page{
  background-color:#E9ECF1;
  width:50vw;
  margin-right:auto;
  margin-left:auto;
  min-height: 100vh;
}
.edit_form{
  display:flex;
  flex-direction:column;
  margin-left:100px;
  margin-bottom:30px;
}
.item_to_edit{
  margin-bottom: 20px;
}
.item_to_edit label{
  font-family: arial;
  font-weight: bold;
  font-size: 1.1em;
}
.item_to_edit input{
  font-family: arial;
  font-size: 1em;
  border: solid 1px green;
  width: 200px;
}
.save_button{
  margin-left:100px;
  justify-content: center;
  border:none;
  background-color:rgb(65,184,131);
  color:white;
  border-radius: 6px;
  padding-left: 28px;
  padding-right: 28px;
  padding-top: 10px;
  padding-bottom: 10px;
  text-decoration:none;
  font-size:1em;
}
.save_button:hover{
  background-color: rgb(145,217,184);
  cursor:pointer;
}
.del_button{
  margin-left:20px;
  background-color: #BA0000;
  color:white;
  border:none;
  border-radius: 6px;
  padding-left: 28px;
  padding-right: 28px;
  padding-top: 10px;
  padding-bottom: 10px;
  text-decoration:none;
  font-size:1em;
}
.del_button:hover{
  background-color: #EF6B6B;
  cursor:pointer;
}
.error_grade{
  color:red;
}

@media screen and (max-width: 1650px){
  .movie_edit_page{
    width:800px;
  }
}

@media screen and (max-width: 800px){
  .movie_edit_page{
    width:100%;
  }
  .edit_form{
    margin-left:20px;
  }
  .save_button{
  margin-left:20px;
}
}
</style>